<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.post('/form/formTemplate', { preserveScroll: true })" autocomplete="off">
      <h3>Create Form Template</h3>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="department-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Template Name</label>
              <input id="name" class="input w-full" type="text" placeholder="Enter template name" v-model="form.name" />
              <div v-if="form.errors.name" class="text-error">
                {{ form.errors.name }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Description
              </label>
              <textarea v-model="form.description" class="textarea" placeholder="Enter description in here" />
              <div v-if="form.errors.description" class="text-error">
                {{ form.errors.description }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Who can raise forms of this template? (Form Raisers)</label>
        <multiselect v-model="form.raisers" :multiple="true" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
        </multiselect>
        <div v-if="form.errors.raisers" class="text-error">
          {{ form.errors.raisers }}
        </div>
      </div>

      <!-- Form field -->
      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Define form fields (Fields cannot be edited once the form template is created)</label>
        <button type="button" v-if="form.form_fields.length === 0"
          class="border border-dashed border-gray-400 w-full block h-40 text-base" @click="addField">
          Click to add a new field.
        </button>
        <div v-else class="space-y-10">
          <div v-for="(role_field, index) in form.form_fields">
            <div class="w-full p-3 border border-gray-400 rounded-md">
              <div class="mb-2 flex items-center gap-x-4">
                <button class="block" :id="`dropdownDefaultButton${index}`"
                  :data-dropdown-toggle="`dropdown-table${index}`" type="button" data-dropdown-placement="bottom-start"
                  data-dropdown-offset-distance="5" data-dropdown-offset-skidding="-12">
                  <Icon icon="fa-solid fa-ellipsis-vertical" class="text-gray-500"></Icon>
                </button>
                <div class="font-semibold text-base">Field No. <span class="text-lg font-bold">{{ index + 1 }}</span>
                </div>
              </div>

              <div class="md:flex gap-5 mb-3">
                <div class="flex-1">
                  <label class="text-sm block">Field Name</label>
                  <input autocomplete="off" v-model="form.form_fields[index].name" :id="`fieldName${index}`"
                    class="input w-full" placeholder="Enter field description or label" required>
                </div>
                <div class="flex-1">
                  <label class="text-sm block">Field Type</label>
                  <select v-model="form.form_fields[index].type" :id="`fieldType${index}`" class="dropdown w-full">
                    <option>Text</option>
                    <option>Number</option>
                    <option>Checkbox</option>
                    <option>Radio Button</option>
                    <option>Dropdown</option>
                    <option>Text Area</option>
                    <option>Date</option>
                    <option>File</option>
                  </select>
                </div>
              </div>

              <div class="mb-8 space-y-3"
                v-if="['Checkbox', 'Radio Button', 'Dropdown'].includes(form.form_fields[index].type)">
                <div class="flex items-center" v-for="(option, optionIndex) in form.form_fields[index].options">
                  <Label class="text-sm me-2">{{ optionIndex + 1 }}.</Label>
                  <input v-model="form.form_fields[index].options[optionIndex]"
                    class="border-0 flex-1 focus:ring-0 h-6 focus:border-0 focus:border-b-2 focus:border-orange-500 p-1 border-b border-gray-400">
                  <button type="button" class="ms-5" v-if="form.form_fields[index].options.length > 1"
                    @click="form.form_fields[index].options.splice(optionIndex, 1)">
                    <Icon icon="fa-solid fa-xmark" class="text-gray-500"></Icon>
                  </button>
                </div>
                <div class="flex items-center">
                  <Label class="text-sm me-2 text-orange-500">{{ form.form_fields[index].options.length + 1 }}.</Label>
                  <button class="text-sm text-orange-400 font-semibold underline" type="button"
                    @click="form.form_fields[index].options.push('')">Add option</button>
                </div>
              </div>

              <div class="text-sm flex gap-x-5">
                <div class="flex items-center gap-x-2">
                  <input :disabled="form.form_fields[index].alertable" type="checkbox" class="checkbox"
                    v-model="form.form_fields[index].required">
                  <label :class="{ 'opacity-30': form.form_fields[index].alertable }">Required</label>
                </div>
              </div>

              <!-- Dropdown menu -->
              <div :id="`dropdown-table${index}`"
                class="z-10 hidden bg-white divide-y divide-gray-100 shadow-md border border-gray-300 w-44 dark:bg-gray-700">
                <ul class="py-2 text-sm text-gray-700 dark:text-gray-200"
                  :aria-labelledby="`dropdownDefaultButton${index}`">
                  <li>
                    <button
                      class="w-full text-start block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
                      type="button" @click="() => {
                        hideDropdown(index);
                        addField(index);
                      }">Add new field below</button>
                  </li>
                  <li>
                    <button
                      class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                      type="button" :disabled="index === 0" @click="() => {
                        hideDropdown(index);
                        moveUp(index);
                      }">Move Up</button>
                  </li>
                  <li>
                    <button
                      class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                      type="button" :disabled="index === form.form_fields.length - 1" @click="() => {
                        hideDropdown(index);
                        moveDown(index);
                      }">Move Down</button>
                  </li>
                  <li>
                    <button @click="() => {
                      hideDropdown(index);
                      form.form_fields.splice(index, 1);
                    }" type="button"
                      class="w-full text-start block px-4 py-2 hover:bg-red-100 disabled:opacity-50 disabled:hover:bg-white dark:hover:bg-gray-600 dark:hover:text-white text-red-500">Delete
                      Field
                    </button>
                  </li>
                </ul>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/creationhub/formTemplate" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      
      </div>
    </form>
  </div>
</template>

<script setup>
import { useForm, Link } from '@inertiajs/vue3';
import { watch } from 'vue';
import { initDropdowns, Dropdown } from 'flowbite';

const props = defineProps({
  users: Array
})

const form = useForm({
  name: '',
  description: '',
  raisers: [],
  form_fields: []
});


function addField(index) {
  form.form_fields.splice(index + 1, 0, {
    name: '',
    type: 'Text',
    options: [""],
    required: false,
  })
}

function hideDropdown(index) {
  const target = document.getElementById(`dropdown-table${index}`);
  const trigger = document.getElementById(`dropdownDefaultButton${index}`);

  const dropdown = new Dropdown(target, trigger);
  dropdown.hide();
}

function moveUp(index) {
  var temp = form.form_fields[index];
  form.form_fields[index] = form.form_fields[index - 1];
  form.form_fields[index - 1] = temp;
}

function moveDown(index) {
  var temp = form.form_fields[index];
  form.form_fields[index] = form.form_fields[index + 1];
  form.form_fields[index + 1] = temp;
}

//initializing dropdowns on new fields
watch(form.form_fields, (value) => {
  //needs rework but for now it suffices
  setTimeout(initDropdowns, 100);
})
</script>